/*
** Support for automatic lua code generation
** Waldemar Celes
** Aug 1997
** Version: 2.0
*/

#ifndef toLua_h
#define toLua_h

#include "lua.h"

extern int TOLUA_NUMBER_TAG;
extern int TOLUA_STRING_TAG;
extern int TOLUA_USERDATA_TAG;

#define toLua_ngetobject(narg)	    lua_getparam(narg)
#define toLua_ngetstring(narg)	    toLua_getstring(lua_getparam(narg))
#define toLua_ngetnumber(narg)	    toLua_getnumber(lua_getparam(narg))
#define toLua_ngetfunction(narg)    toLua_getfunction(lua_getparam(narg))
#define toLua_ngetusertag(narg,tag) toLua_getusertag(lua_getparam(narg),tag)
#define toLua_ngetuserdata(narg)    toLua_getuserdata(lua_getparam(narg))


#define toLua_igetobject(index,lt)	\
	lua_getindexed(lt)
#define toLua_igetstring(index,lt)	\
	toLua_getstring(lua_getindexed(lt,index))
#define toLua_igetnumber(index,lt)	\
	toLua_getnumber(lua_getindexed(lt,index))
#define toLua_igetfunction(index,lt) 	\
  	toLua_getfunction(lua_getindexed(lt,index))
#define toLua_igetusertag(index,tag,lt)	\
  	toLua_getusertag(lua_getindexed(lt,index),tag)
#define toLua_igetuserdata(index,lt)	\
     	toLua_getuserdata(lua_getindexed(lt,index))

#define toLua_pushobject(o)          lua_pushobject(o)
#define toLua_pushnumber(n)          lua_pushnumber((float)n)
#define toLua_pushuserdata(v)        toLua_pushusertag(v,0) 
void    toLua_pushstring (char* s);
void    toLua_pushusertag (void* v, int tag);
void    toLua_pushuservalue (void* v, int size, int tag);

void toLua_wrongself (char* funcname);
void toLua_wrongarg (char* funcname, int narg, char* tname);
void toLua_wrongarray (char* funcname, int narg, char* tname, int dim);
void toLua_toomanyargs (char* funcname);

int        toLua_newtag(char *type);
void       toLua_registerparent (int derived, int base, void* (*fcast)(void*));
int        toLua_istype (lua_Object lo, int type);
int        toLua_nistype (int index, int type);
int        toLua_nisarray (int index, int type, int dim);

lua_Object toLua_gettable (lua_Object o);
char      *toLua_getstring (lua_Object o);
float      toLua_getnumber (lua_Object o);
lua_Object toLua_getfunction (lua_Object o);
void      *toLua_getuserdata (lua_Object o);
void      *toLua_getusertag (lua_Object o, int tag);
void       toLua_getfb (int tag, char *f, void *fb);
void       toLua_setfb (int tag, char *f, void *fb);
void       toLua_funcfb (int tag, char *f, lua_CFunction fb);
void       toLua_libtag (char *lib);
void       toLua_getfb_extern (char *lib, char *var, void *fb);
void       toLua_setfb_extern (char *module, char *var, void *fb);
void       toLua_init (void);

#endif
